#ifdef PSX

#include	"syscall.h"
typedef	volatile long*	vptr;

#define	gp0	(*(vptr)0x1f801810)
#define	gp1	(*(vptr)0x1f801814)
#define	d2_madr	(*(vptr)0x1f8010a0)
#define	d2_bcr	(*(vptr)0x1f8010a4)
#define	d2_chcr	(*(vptr)0x1f8010a8)

void	GPU_WaitIdle(void)
{
	do ; while(((long)gp1<<(31-26))>=0);
	gp1 = 0x04000000; /* set i/o mode */
}

void	GPU_Sync(void)
{
	if (!(gp1&0x60000000)) {
		do ; while(((long)gp1<<(31-28))>=0) ;
	} else {
		do ; while(((long)d2_chcr<<(31-24))<0) ;
	}
}


#define	Clear_()
//#define	SendGPU	SetGPUStatus
#define SendGPU(a)	gp1=a
#define GPU_cw(a)	_GPU_cw(a)

//int TestCard(int no) {return 0;}

void _GPU_cwb(unsigned long *data,int len)
{
	do ; while(((long)gp1<<(31-26))>=0);
#if 0
	gp1 = 0x04000000; /* set i/o mode */
	gp0 = 0x01000000; //command reset
#endif
	do {
		gp0=*data++;
	} while (--len);
}

void _GPU_cw(unsigned long data)
{
	GPU_Sync();
	gp0 = data;
}

void Rectangle(int x , int y , int w , int h , int R , int G , int B)
{
	long local[3];

	local[0] = ((B << 16) | 0x60000000) | (G << 8) | (R);
	local[1] = (y << 16) | (x);
	local[2] = (h << 16) | (w);
	GPU_cwb(local , 3);
}

void	LoadImage(unsigned long *rect,unsigned long *data);

void PsInit(void)
{
	SendGPU(0);		/* Some kind of reset ? */
	Clear_();
	SendGPU(0x03000000);	/* Display Mask (enable display) */
	Clear_();
	SendGPU(0x06c60260);	/* Screen horizontal start/end */
	Clear_();
	SendGPU(0x07040010);	/* Screen vertical start/end */
	Clear_();
	GPU_cw(0xe1000400);	/* Draw on display area */
	Clear_();
	GPU_cw(0xe3000000);	/* Draw Area x, y */
	Clear_();
	GPU_cw(0xe407ffff);	/* Draw Area w, h */
	Clear_();
	GPU_cw(0xe5000000);	/* Draw Offset */
	Clear_();
	SendGPU(0x08000000);	/* Display mode, 256x240/NTSC/noninterlaced */
	Clear_();
	Rectangle(  0,   0,  320, 256, 0, 0, 0);
	Rectangle(  0,   256,  320, 256, 0, 0, 0);
	//Rectangle(  0,   0,  32, 241, 255, 255, 255);
}

#if 1
void	LoadImage(unsigned long *rect,unsigned long *data)
{
	unsigned long	size;
	size = rect[1];
	size = (size>>16)*(size&0xffff)/2;
	GPU_WaitIdle();

	gp0 = 0x01000000; //command reset
	gp0 = 0xa0000000; //rect set
	gp0 = rect[0];
	gp0 = rect[1];
	do {
		gp0=*data++;
	} while(--size);
}
#else

void	_LoadImageIO(unsigned long *rect,unsigned long *data)
{
	unsigned long	size;
	size = rect[1];
	size = (size>>16)*(size&0xffff);
	GPU_WaitIdle();

	gp0 = 0x01000000; //command reset
	gp0 = 0xa0000000; //rect set
	gp0 = rect[0];
	gp0 = rect[1];

	gp1 = 0x40000002; // mem2vram;
	d2_madr = data;
	d2_bcr = ((size)<<16)|16;
	d2_chcr = 0x01000201;
}
#endif

#endif
