/*
 * psx.c - a Driver for Playstation
 *
 * by BERO
 */

#if( defined(PSX) )
#include <stdio.h>
#include <stdlib.h>
#include <sys/file.h>
#include "pad.h"
#include "syscall.h"

/* Private includes */

typedef unsigned char byte;

#ifdef SOUND
#include "SB.h"
#endif

/* Sound related stuff */
#ifdef SOUND
int UseSound = 0;
int SndSwitch = 0x0F;
int SndVolume = 200;
#endif

int Verbose = 1;
int Debug=1;

static int changepal;
static int CPURunning;

static	volatile unsigned char *pad1, *pad2;

long PadRead(int id)
{
	return(~(pad1[3] | pad1[2] << 8 | pad2[3] << 16 | pad2[2] << 24));
}

void GetPadBuf(volatile unsigned char **p1, volatile unsigned char **p2)
{
	static volatile unsigned char pad1[34],pad2[34];
	*p1 = pad1;
	*p2 = pad2;
	InitPAD(pad1,sizeof(pad1),pad2,sizeof(pad2));
	StartPAD();
}

/* TrashMachine - Uninitialise everything */
void TrashMachine(void)
{
 if( Verbose ) printf("Shutting down...\n");
 
#ifdef SOUND
 TrashSound();
#endif 
	StopPAD();
}

int vmode=0;
/* InitMachine - Starts up all the Unix/SVGA related stuff */
int InitMachine(void)
{
 int i, j;

 if( Verbose ) 
   printf("Initialising PSX driver:\n Allocating buffers...\n");

 PsInit();

 if( Verbose )
   printf("OK\n Initing sound...\n");
 
#ifdef SOUND
 InitSound(UseSound);
 SetChannels(SndVolume,SndSwitch);
 SetSound(3,SND_NOISE);
#endif SOUND
 
	GetPadBuf(&pad1,&pad2);
	printf("PadInit OK\n");
	return(1);
}

/* Josticks - Handles input. Due to differences between SVGAlib and X, this
 * may be a bit bonkers. You have been warned. Due to SVGAlib, and my 
 * laziness, only a select few keys are supported. But anyway, the key 
 * mappings I have dropped are nasty, horrid ones. So don't worry.
 */

#define	JOY_A		1
#define	JOY_B		2
#define	JOY_SELECT	4
#define	JOY_START	8
#define	JOY_UP		0x10
#define	JOY_DOWN	0x40
#define	JOY_LEFT	0x80
#define	JOY_RIGHT	0x20

int Joysticks(void)
{
	int JS;
	long padd = PadRead(0);
	JS = 0;

	if ((padd&(PADL1|PADR1))==(PADL1|PADR1))	JS|=0x10000;
	if (padd&PADLup)	JS|=JOY_UP;
	if (padd&PADLdown)	JS|=JOY_DOWN;
	if (padd&PADLleft)	JS|=JOY_LEFT;
	if (padd&PADLright)	JS|=JOY_RIGHT;
	if (padd&PADRright)	JS|=JOY_A; /* FIRE A */
	if (padd&PADRdown)	JS|=JOY_B; /* FIRE B */
	if (padd&PADstart)	JS|=JOY_START; /* START */
	if (padd&PADselect)	JS|=JOY_SELECT; /* PAUSE */

	return JS;
}

#endif
